/*$Id: asciredstubs.c,v 1.10 2000/03/25 00:09:46 balay Exp $*/
/*
  System function stubs, contributed by Darin Diachin - diachin@mcs.anl.gov

  This source file contains stubs for some system functions, which are
  not avilable on the ASCI Red machine. These stubs enable us to build
  Petsc executables. But if the code goes and requests these functions,
  then they will not work as the regular system functions do.
*/

#include "petsc.h"
#if defined (PARCH_ascired)
#include <sys/types.h>
#include <unistd.h>

EXTERN_C_BEGIN
int socket(int domain,int type,int protocol)
{
   PetscPrintf(PETSC_COMM_SELF,"POSSIBLE PROBLEM: entered socket, in %s\n",__FILE__);
   return 0;
}

struct hostent *gethostbyname(const char *name)
{
   PetscPrintf(PETSC_COMM_SELF,"POSSIBLE PROBLEM: entered gethostbyname, in %s\n",__FILE__);
   return 0;
}
EXTERN_C_END

int getpagesize(void)
{
   PetscPrintf(PETSC_COMM_SELF,"POSSIBLE PROBLEM: entered getpagesize, in asciredstub.c\n",__FILE__);
   return 0;
}

int *getpwuid(void)
{
   PetscPrintf(PETSC_COMM_SELF,"POSSIBLE PROBLEM: entered getpwuid, in %s\n",__FILE__);
   return 0;
}

int setsockopt(int s,int level,int optname,const char *optval,int optlen)
{
   PetscPrintf(PETSC_COMM_SELF,"POSSIBLE PROBLEM: entered setsockopt, in %s\n",__FILE__);
   return 0;
}

pid_t fork(void)
{
   pid_t stub=0;
   PetscPrintf(PETSC_COMM_SELF,"POSSIBLE PROBLEM: entered fork, in %s\n",__FILE__);
   return stub;
}

pid_t getppid(void)
{
   pid_t stub=0;
   PetscPrintf(PETSC_COMM_SELF,"POSSIBLE PROBLEM: entered getppid, in %s\n",__FILE__);
   return stub;
}

int execvp (const char *file,char *const argv[])
{
   PetscPrintf(PETSC_COMM_SELF,"POSSIBLE PROBLEM: entered execvp, in %s\n",__FILE__);
   return 0;
}

FILE *popen(char *command,char *type)
{
  PetscPrintf(PETSC_COMM_SELF,"POSSIBLE PROBLEM: entered popen, in %s\n",__FILE__);
  return 0;
}


int pclose(FILE *stream)
{
  PetscPrintf(PETSC_COMM_SELF,"POSSIBLE PROBLEM: entered pclose, in %s\n",__FILE__);
  return 0;
}


#else

int asciredstubs_dummy(void)
{
  return 0;
}
#endif
